import {ENDPOINT_USE_BEFORE} from "../constants/metadata-keys";
import {Metadata} from "../services";
import {Endpoint} from "../controllers/endpoint";

/**
 * Use decorator.
 * @returns {function(any, any, any): *}
 * @constructor
 * @param args
 */
export function UseBefore(...args: any[]): Function {

    return <T> (
        target: Function,
        targetKey: string,
        descriptor: TypedPropertyDescriptor<T>
    ) : TypedPropertyDescriptor<T> => {

        Endpoint.useBefore(target, targetKey, args);

        return descriptor;
    };
}